// Full Expand part of hf map using splines to evaluate between pixels values.
// Smooth Mesh2 or Data 
// with pattern morph & save
// shown facing the -z direction
// mesh facing the -z dirction
// Points data just the high points for an array
//2.6 km per pixel

#include "colors.inc"
 global_settings{assumed_gamma 1.0  
                 max_trace_level 50 }
camera{ location <0,0,-135>//-350
        right x*image_width/image_height
        look_at <0,0,0>
        }
background{Blue*.5}
light_source{ <250,0,-200> color White}
//light_source{ <0,201,-100> color White}

//============= Changes ======================
 //--------Save to file ------------------
 // comment out to not save
 //#declare SavMesh="G:\\PovPrt\\Mesh\\Landcenter.hf";
 //#declare Pointdata="G:\\PovPrt\\Mesh\\Invent.dat";
 //------- show changes---------

 #declare Mark=0; //Show Center
 #declare ShowOld=1;// show old pixel locations

//----------- Change for Mesh-----------------
 #declare Pig=pigment{image_map { tga "fflip46b.tga"} }
 #declare Pw=8192-1;// width  of image
 #declare Ph=4096-1;// height of image

 #declare PntE=<10,10>;//pixcel Rectangle to evaluate

 #declare Spltype=1;//spline types 0-linear 1-natural 
 #declare Dt=5;// divions delta >=1
 #declare Height=60*Dt;// height of points !=0
 #declare adjustLow=1;//adjust to lowest point  0= no 1=yes

 #declare Mor=150/65535;//morph value <1
 #declare Mortp=1;//morph type 0,1
 //  \|/ commment out for no morph  \|/
 //#declare Rfnc = function {pattern {granite scale <.5,.5,81>}}//morph pattern

//   longitude & latitude
#declare Long=142;//0 to +-180  west=-
#declare Lat= -50;//0 to +-90   south=-

//============ end of changes ================

//#include"MarsLL.inc"// get longitude & latitude
#if (Long<0) #declare Ts=Pw+Pw*(Long/360);
#else    #declare Ts=Pw*(Long/360);
#end
#declare  Tr=Ph*abs(Lat-90)/180;

#declare Ts=Ts+15;// for Landcenter
#declare Tr=Tr+7;// for Landcenter

#debug concat("\nTs=",str(Ts,0,0)"  Tr=",str(Tr,0,0),"\n")
#debug concat("\nRectangle=<",str(Ts-PntE.x,0,0),",",str(Tr-PntE.y,0,0)">,")
#debug concat("<",str(Ts+PntE.x,0,0),",",str(Tr+PntE.y,0,0)">\n")
#declare PntS=<Ts-PntE.x,Tr-PntE.y>;

// show mark
#if (Mark) cylinder {0,-z*Height,1 pigment{Red}} 
           //cylinder {<60,-30,0>,<60,-30,-Height>,1 pigment{Red}} 
#end

// #include "functions.inc"
   #declare Pfnc = function {pigment {Pig} }
   #declare Qfnc = function {Pfnc(x,y,z).gray}

#declare a=PntE.x*Dt*2;
#declare b=PntE.y*Dt*2;

 #debug concat("\nA="str(a,3,3)"\n")
 #debug concat("B="str(b,3,3)"\n\n")
#debug concat("Mesh Points ",str(a*b,0,0),"\n") 
#debug concat("Mesh trangles ",str(2*(a-1)*(b-1),0,0),"\n") 
 
#declare Jtab=array[a][b];

#macro Hloc(J) // find color and heigth Ic,Ip
 #local TG=<J.x/Pw,(Ph-J.y)/Ph,0>; 
 //#declare Ic=eval_pigment(Pig,<TG.x,TG.y,0>);
 #declare Ip=Qfnc(TG.x,TG.y,0);
#end

// #declare Ip=Qfnc(0,0,0);
// #debug concat("Ip="str(Ip,3,3)"\n\n")

//---------- first Fill old pixels----------
#declare Lowp=999;
#declare Hip=-999;
#declare Cnt = 0;
#while (Cnt < a)
 #declare Cnt2 = 0;
 #while (Cnt2 < b)
  #declare Tp=<Cnt/Dt,Cnt2/Dt,0>+PntS;
  Hloc(Tp)
  #declare Jtab[Cnt][Cnt2]=Ip;
  #if(Ip<Lowp) #declare Lowp=Ip; #end
  #if(Ip>Hip) #declare Hip=Ip; #end
 #declare Cnt2 = Cnt2+Dt; 
 #end
#declare Cnt = Cnt+Dt; 
#end
   #debug concat("\nLowp= "str(Lowp*Height,3,3)"\n")
   #debug concat(" Hip= "str(Hip*Height,3,3)"\n")

#if(adjustLow)
 #declare Cnt = 0;
 #while (Cnt < a)
  #declare Cnt2 = 0;
  #while (Cnt2 < b)
   #declare Jtab[Cnt][Cnt2]=Jtab[Cnt][Cnt2]-Lowp;
  #declare Cnt2 = Cnt2+Dt; 
  #end
 #declare Cnt = Cnt+Dt; 
 #end
#end

//-------new Moprh-------------
#if (Mortp=0)
#ifdef (Rfnc)
 #declare Cnt = 0;
 #while (Cnt < a)
  #declare Cnt2 = 0;
  #while (Cnt2 <b)
    #declare Jtab[Cnt][Cnt2]=Jtab[Cnt][Cnt2]+Rfnc(Cnt,Cnt2,0)*2*Mor-Mor;  
  #declare Cnt2 = Cnt2+Dt; 
  #end
 #declare Cnt = Cnt+Dt; 
 #end
#end 
#end


#if (Dt>1)
 //----------- line fill 1 -------------
 #declare Cnt2=0;
 // make spline
 #while (Cnt2<b)
 #declare SplA=spline{#if (Spltype=0) linear_spline 
                      #else natural_spline
                      #end
   #declare Cnt = 0;
   #while (Cnt < a)
      #ifdef(Jtab[Cnt][Cnt2])  Cnt/(a-1),<0,Jtab[Cnt][Cnt2]>  #end
   #declare Cnt = Cnt+1; 
   #end
  }
 #declare Cnt = 1;
// use spline
 #while (Cnt < a)
   #ifndef(Jtab[Cnt][Cnt2]) 
    #declare Vt=SplA(Cnt/(a-1)); 
    #declare Jtab[Cnt][Cnt2]=Vt.y; 
   #end
 #declare Cnt = Cnt+1; 
 #end
 #declare Cnt2 = Cnt2+Dt; 
 #end
 //----------- line fill 2 -------------
 #declare Cnt=0;
// make spline
 #while (Cnt<a)
  #declare SplA=spline{#if (Spltype=0) linear_spline 
                      #else natural_spline
                      #end
   #declare Cnt2 = 0;
   #while (Cnt2 < b)
       #ifdef(Jtab[Cnt][Cnt2]) 
       Cnt2/(b-1),<0,Jtab[Cnt][Cnt2]> 
       #end
   #declare Cnt2 = Cnt2+1; 
   #end
  }
//use spline
  #declare Cnt2 = 1;
  #while (Cnt2 < b)
   #ifndef(Jtab[Cnt][Cnt2]) 
     #declare Vt=SplA(Cnt2/(b-1)); 
     #declare Jtab[Cnt][Cnt2]=Vt.y; 
    //#if(Jtab[Cnt][Cnt2]<0)  #declare Jtab[Cnt][Cnt2]=0; #end
    //#if(Jtab[Cnt][Cnt2]>1)  #declare Jtab[Cnt][Cnt2]=1; #end
   #end
  #declare Cnt2 = Cnt2+1; 
  #end
 #declare Cnt = Cnt+1; 
 #end

#end
//-------old Moprh-------------
#if (Mortp=1)
#ifdef (Rfnc)
 #declare Cnt = 0;
 #while (Cnt < a)
  #declare Cnt2 = 0;
  #while (Cnt2 <b)
    #declare Jtab[Cnt][Cnt2]=Jtab[Cnt][Cnt2]+Rfnc(Cnt,Cnt2,0)*2*Mor-Mor;  
  #declare Cnt2 = Cnt2+1; 
  #end
 #declare Cnt = Cnt+1; 
 #end
#end 
#end


/*/ -------show area-------------
#declare Cnt = 0;
#while (Cnt < a)
 #declare Cnt2 = 0;
 #while (Cnt2 < b)
  sphere{<Cnt-(a/2),(b/2)-Cnt2,0>,.1 pigment{Blue}}
  #ifdef(Jtab[Cnt][Cnt2]) 
   //sphere{<Cnt-(a/2),(b/2)-Cnt2,0>,.5 pigment{rgb Jtab[Cnt][Cnt2]}}
   box{-.5,.5 pigment{rgb Jtab[Cnt][Cnt2]}
    translate <Cnt-(a/2),(b/2)-Cnt2,0>}
  #end 
 #declare Cnt2 = Cnt2+1; 
 #end
#declare Cnt = Cnt+1; 
#end
*/
#declare Pnts=array[a*b];
#declare Facs=array[2*(a-1)*(b-1)];
#declare Norm=array[a*b];

//points
   #declare N = 0;
   #declare Cnt2 = 0;
   #while (Cnt2 < b)
    #declare Cnt = 0;
     #while (Cnt < a)
      #declare Pnts[N]=<Cnt-(a/2),(b/2)-Cnt2,-Jtab[Cnt][Cnt2]*Height>;
     #declare N=N+1; 
     #declare Cnt = Cnt+1; 
     #end
    #declare Cnt2 = Cnt2+1; 
    #end
//faces
   #declare N = 0;
    #declare Z = 0;
     #while (Z < b-1)
    #declare X = 0;
      #while (X < a-1)
       #declare Facs[N]=<Z*(a)+X,Z*(a)+X+1,(Z+1)*(a)+X+1>;
       #declare N=N+1; 
       #declare Facs[N]=<Z*(a)+X,(Z+1)*(a)+X+1,(Z+1)*(a)+X>;
       #declare N=N+1; 
     #declare X = X+1; 
     #end
   #declare Z = Z+1; 
   #end
//norms
 #declare Cnt = 0;
 #while (Cnt < a*b)
         #declare Norm[Cnt]=<0,0,0>;
 #declare Cnt = Cnt+1; 
 #end

 #declare Cnt = 0;
 #while (Cnt < 2*(a-1)*(b-1))
     #declare Nbase=Facs[Cnt];
     //#debug concat(" Tri < " vstr(3,Nbase,",",3,3)," >\n")
    #declare Face=vcross(Pnts[Nbase.x]-Pnts[Nbase.z],Pnts[Nbase.x]-Pnts[Nbase.y]);
    //#debug concat("   Face= < " vstr(3,Face,",",3,3)," >\n")
    #declare Norm[Nbase.x]=Norm[Nbase.x]+Face;
    #declare Norm[Nbase.y]=Norm[Nbase.y]+Face;
    #declare Norm[Nbase.z]=Norm[Nbase.z]+Face;

 #declare Cnt = Cnt+1; 
 #end
 #while (Cnt <a*b)
    #if((Norm[Cnt].x+Norm[Cnt].y+Norm[Cnt].z)!=0)  
      #declare Norm[Cnt]=vnormalize(Norm[Cnt]);
    #else #debug concat("Normal vector ZERO at point " str(Cnt,3,3),"\n") 
    #end
 //#debug concat("   Cnt= < " str(Cnt,3,3),"\n")
 #declare Cnt = Cnt+1; 
 #end


//--------- mesh2--------------
mesh2{
  vertex_vectors{a*b 
    #declare Cnt=0;
    #while(Cnt<a*b)
     Pnts[Cnt] 
     #declare Cnt=Cnt+1;
    #end
    }
  normal_vectors {a*b, 
    #declare Cnt=0;
    #while(Cnt<a*b)
     Norm[Cnt] 
     #declare Cnt=Cnt+1;
    #end
    } 

  face_indices{2*(a-1)*(b-1)
    #declare Cnt=0;
    #while(Cnt<2*(a-1)*(b-1))
     Facs[Cnt] 
     #declare Cnt=Cnt+1;
    #end
}
 
// pigment{gradient z color_map{[0 Black][.25 Blue][.5 Red]
//                              [.75 Green][1 White]} scale 5}
pigment{Gold}
//pigment{gradient z color_map{[0 Gold][.5 Blue][1 Red]}}
/*
pigment{gradient -z 
 //color_map{[0 Pink*.5][.25 Brown*.5][.5 Gold][.75 Brown][1 White]}
   color_map{Cmap} //turbulence .2 
  scale <500,500,Height>}
*/
 //normal{agate scale<.1,.1,.1>}
 //scale .25
 }

//show old pixel loc
#if(ShowOld)
    #declare Cnt=0;
    #while(Cnt<a)
     #declare Cnt2=0;
     #while(Cnt2<b)
     sphere{<Cnt-(a/2),(b/2)-Cnt2,-Jtab[Cnt][Cnt2]*Height-.2>,.2 
            pigment{Red}}
     #declare Cnt2=Cnt2+Dt;
    #end
    #declare Cnt=Cnt+Dt;
    #end
#end    


#ifdef(SavMesh)
 #fopen MyFile SavMesh write
 #write (MyFile "mesh2{\n")
 #write (MyFile "vertex_vectors {\n",a*b,",")
    #declare Cnt=0;
    #declare Cnt2=0;
    #while(Cnt<a*b)
     #if (Cnt!=a*b-1)
     #write (MyFile "<",vstr(3,Pnts[Cnt] ,",",0,9),">,")            
     #else
     #write (MyFile "<",vstr(3,Pnts[Cnt],",",0,9),">")            
     #end
     #if (Cnt2=5)
      #declare Cnt2=0;
       #write (MyFile "\n")            
    #end
     #declare Cnt2=Cnt2+1;
     #declare Cnt=Cnt+1;
  #end
 #write (MyFile "}\n")


 #write (MyFile "normal_vectors {\n",a*b,",")            
        #declare Cnt=0;
        #declare Cnt2=1;
    #declare Cnt=0;
    #while(Cnt<a*b)
  #while(Cnt<a*b)
     //PntAr[Cnt] 
   #if (Cnt!=a*b-1)
   #write (MyFile "<",vstr(3,Norm[Cnt],",",0,9),">,")            
   #else
   #write (MyFile "<",vstr(3,Norm[Cnt],",",0,9),">")            
   #end
     #if (Cnt2=5)
      #declare Cnt2=0;
      #write (MyFile "\n")            
     #end
   #declare Cnt2=Cnt2+1;
   #declare Cnt=Cnt+1;
  #end
 #write (MyFile "}\n")
#end
/*
  face_indices{2*(a-1)*(b-1)
    #declare Cnt=0;
    #while(Cnt<2*(a-1)*(b-1))
     Facs[Cnt] 
     #declare Cnt=Cnt+1;
    #end
*/
 #write (MyFile "face_indices {\n",2*(a-1)*(b-1),",")            
        #declare Cnt=0;
        #declare Cnt2=1;
  #while(Cnt<2*(a-1)*(b-1))
     //PntAr[Cnt] 
   #if (Cnt!=2*(a-1)*(b-1)-1)
   #write (MyFile "<",vstr(3,Facs[Cnt],",",0,0),">,")            
   #else
   #write (MyFile "<",vstr(3,Facs[Cnt],",",0,0),">")            
   #end
     #if (Cnt2=5)
      #declare Cnt2=0;
       #write (MyFile "\n")            
     #end
   #declare Cnt2=Cnt2+1;
   #declare Cnt=Cnt+1;
  #end
 #write (MyFile "}\n")
 #write (MyFile "}\n")
#end
#ifdef(Pointdata)
  #fopen MyFile Pointdata write
 #write (MyFile a,","b,",\n")
    #declare Cnt=0;
    #declare Cnt2=0;
    #while(Cnt<a*b)
     #if (Cnt!=a*b-1)
     #write (MyFile abs(Pnts[Cnt].z),",")            
     #else
     #write (MyFile abs(Pnts[Cnt].z))            
     #end
     #if (Cnt2=5)
      #declare Cnt2=0;
       #write (MyFile "\n")            
     #end
     #declare Cnt2=Cnt2+1;
     #declare Cnt=Cnt+1;
  #end 
#end  
 